//******************************************
//           This is a C Template file
//
//
//
//ע
//******************************************
#include "MQ6821.h"
#include "ADC.h"


//*********************************************************************
// 	: GetVref()
// 	: ȡADC ڲVref 2V֮ʵֵ(λΪmV),  (ADC_vref2v)
// 			: ȡֵΪ ( ڲVref 2V֮ʵֵ * 1024 ), λΪmV
// ע		: ADCԶ:(MULCTR)(0x0EF6)=0x02
//*********************************************************************
uint GetVref(void)
{
	TYPE_WORD ADC_READ;
//	Vref2V, value is ( Real_2V * 1024 )
	__asm("LD A,(0x7E05)");		// low byte
	__asm("LD (_vref_l),A");
	__asm("LD A,(0x7E06)");		// high byte
	__asm("LD (_vref_h),A");

	ADC_READ.byte[0] = vref_l;
	ADC_READ.byte[1] = vref_h & 0x0f;

	MULCTR.byte = 0x02;			// ADCԶ:(MULCTR)(0ex0EF6)=0x02
	if( ADC_READ.word > 2150 )	MULCTR.byte = 0x00;	//  Vref2VΧ, ADCԶ
	if( ADC_READ.word < 1950 )	MULCTR.byte = 0x00;	//  Vref2VΧ, ADCԶ
	return ADC_READ.word;
}
//uint GetVref(void)
//{
////	__asm("LD A,(0x7E05)");		// low byte
////	__asm("LD A,(0x7E06)");		// high byte
//	uint *adc_value = (uint*)(0x7E05);
//	uint adc_read;

//	adc_read = *adc_value & 0x0fff;
//	MULCTR.byte = 0x02;			// ADCԶ:(MULCTR)(0ex0EF6)=0x02
//	if( adc_read > 2150 )	MULCTR.byte = 0x00;	//  Vref2VΧ, ADCԶ
//	if( adc_read < 1950 )	MULCTR.byte = 0x00; //  Vref2VΧ, ADCԶ
//	return adc_read;
//}


//*********************************************************************
// 	: ADC_detect()
// 	: 32(ADC_count)ת, ȡ32ADC֮ܺ(ADC_sum)
// ע		: ȡ32ƽ ( ad_test_times = 32 趨)
//*********************************************************************
ulong ADC_detect(uchar VREF, uchar SAIN, uchar ACK, uchar AMD)
{
	char  i;
	ulong adc_data = 0;
	TYPE_WORD ADC_READ;

//	ADC Config set ......
	ADCVRF.byte  = VREF;
	ADCCR1.byte  = SAIN;	// 1. 趨SAINѡAD תģźͨ
	ADCCR1.byte |= 16;		// 2. 趨ģźAINEN Ϊ"ģź"
	ADCCR1.byte |= AMD*32;	// 3. 趨AMDѡAD תģʽΪλظģʽ
	ADCCR2.byte  = ACK;

//	ADC Single mode ......
	if( AMD == ADC_Single )
	{
		for( i=0; i<ad_test_times; i++ )
		{
			ADCCR1.bit.b7 = 1;			// start adc
			while(  ADCCR2.bit.b6 ){}	// ȴadcʼת
			while( !ADCCR2.bit.b7 ){}	// ȴadcת
			ADC_READ.byte[0] = ADCDRL.byte;
			ADC_READ.byte[1] = ADCDRH.byte;
			adc_data += ADC_READ.word;
		}
	}
//	ADC Repeat mode ......
	else
	{
		ADCCR1.bit.b7 = 1;				// start adc
		for( i=0; i<ad_test_times; i++ )
		{
			while( !ADCCR2.bit.b7 ){}	// ȴadcת
			ADC_READ.byte[0] = ADCDRL.byte;
			ADC_READ.byte[1] = ADCDRH.byte;
			adc_data += ADC_READ.word;
		}
		ADCCR1.byte = 0x00;				// stop adc
	}

	return adc_data;
}


//*********************************************************************
// 	: ADC_ConvCode()
// 	:
// ע		: ADתΪ AIN ֮ ADC Code
// 			: fcgck=16M... Conv256CLK(16us) ~ Conv1024CLK( 64us)
// 			: fcgck= 8M... Conv128CLK(16us) ~ Conv1024CLK(128us)
// 			: fcgck= 4M... Conv64CLK (16us) ~ Conv512CLK (128us)
// 			: fcgck= 2M... Conv32CLK (16us) ~ Conv256CLK (128us)
//*********************************************************************
ulong ADC_ConvCode(uchar VREF, uchar SAIN, uchar ACK, uchar AMD)
{
	if( VREF == Vref2 )
	{
		adc_value = ADC_detect(VREF,    SAIN, ACK, AMD);
		adc_GND   = ADC_detect(VREF, AIN_GND, ACK, AMD);	// ڲֵصƫ

	//	ȥADCƫ, ȱȽADC, ADCСƫ, ȡADCΪ0
	//	תΪ ADC Code
		if( adc_value > adc_GND )	adc_value = (adc_value - adc_GND) / ad_test_times;
		else						adc_value = 0;
	}
	else
	{
		adc_value = ADC_detect(VREF, SAIN, ACK, AMD) / ad_test_times;
	}

	return adc_value;
}

//*********************************************************************
// 	: ADC_ConvVolt()
// 	:
// ע		: ADתΪ AIN ֮ ѹֵ(mV)
// 			: fcgck=16M... Conv256CLK(16us) ~ Conv1024CLK( 64us)
// 			: fcgck= 8M... Conv128CLK(16us) ~ Conv1024CLK(128us)
// 			: fcgck= 4M... Conv64CLK (16us) ~ Conv512CLK (128us)
// 			: fcgck= 2M... Conv32CLK (16us) ~ Conv256CLK (128us)
//*********************************************************************
ulong ADC_ConvVolt(uchar VREF, uchar SAIN, uchar ACK, uchar AMD)
{
	if( VREF == Vref2 )
	{
		adc_value = ADC_detect(VREF,    SAIN, ACK, AMD);
		adc_GND   = ADC_detect(VREF, AIN_GND, ACK, AMD);	// ڲֵصƫ

//P8DR.bit.b1 = 1;	// ۲ִʱ䣬ɾ
	//	ȥADCƫ, ȱȽADC, ADCСƫ, ȡADCΪ0
	//	תΪ ADC Voltage
		if( adc_value > adc_GND )	adc_value = ((adc_value - adc_GND)*2000) / 1024 / ad_test_times;
		else						adc_value = 0;
//P8DR.bit.b1 = 0;	// ۲ִʱ䣬ɾ
		return adc_value;
	}

	return 9999;	// ֻVREF2V, 򴫻ع̶ֵ
}

//********> cADC_correct = ( iADC_value*iReal_Vref2V ) / 2000 / 32;
//ADC_correct_code()_  = ƽֵ*ʵʲοѹ/οѹ
//  adc_codeıȽ, ѡڲ2Vοѹ
//********> vADC_correct = cADC_correct * 2000 / 1023;
//ADC_correct_voltage(mV)_ = ADC_correct_code()*οѹ/1023
// ĿѹֵȽ, ѡڲ2Vοѹ














